import type { GraphQLClient } from 'graphql-request';
import type * as Dom from 'graphql-request/dist/types.dom';
import gql from 'graphql-tag';
export type Maybe<T> = T;
export type InputMaybe<T> = T;
export type Exact<T extends { [key: string]: unknown }> = { [K in keyof T]: T[K] };
export type MakeOptional<T, K extends keyof T> = Omit<T, K> & { [SubKey in K]?: Maybe<T[SubKey]> };
export type MakeMaybe<T, K extends keyof T> = Omit<T, K> & { [SubKey in K]: Maybe<T[SubKey]> };
/** All built-in and custom scalars, mapped to their actual values */
export type Scalars = {
  ID: string;
  String: string;
  Boolean: boolean;
  Int: number;
  Float: number;
  Date: any;
  ObjectID: any;
  timestamptz: any;
  uuid: any;
};

export type GQLAddress = {
  readonly __typename?: 'Address';
  readonly address: Maybe<Scalars['String']>;
  readonly city: Maybe<Scalars['String']>;
  readonly state: Maybe<Scalars['String']>;
};

export type GQLCapsule = {
  readonly __typename?: 'Capsule';
  readonly dragon: Maybe<GQLDragon>;
  readonly id: Maybe<Scalars['ID']>;
  readonly landings: Maybe<Scalars['Int']>;
  readonly missions: Maybe<ReadonlyArray<Maybe<GQLCapsuleMission>>>;
  readonly original_launch: Maybe<Scalars['Date']>;
  readonly reuse_count: Maybe<Scalars['Int']>;
  readonly status: Maybe<Scalars['String']>;
  readonly type: Maybe<Scalars['String']>;
};

export type GQLCapsuleMission = {
  readonly __typename?: 'CapsuleMission';
  readonly flight: Maybe<Scalars['Int']>;
  readonly name: Maybe<Scalars['String']>;
};

export type GQLCapsulesFind = {
  readonly id: InputMaybe<Scalars['ID']>;
  readonly landings: InputMaybe<Scalars['Int']>;
  readonly mission: InputMaybe<Scalars['String']>;
  readonly original_launch: InputMaybe<Scalars['Date']>;
  readonly reuse_count: InputMaybe<Scalars['Int']>;
  readonly status: InputMaybe<Scalars['String']>;
  readonly type: InputMaybe<Scalars['String']>;
};

export type GQLCore = {
  readonly __typename?: 'Core';
  readonly asds_attempts: Maybe<Scalars['Int']>;
  readonly asds_landings: Maybe<Scalars['Int']>;
  readonly block: Maybe<Scalars['Int']>;
  readonly id: Maybe<Scalars['ID']>;
  readonly missions: Maybe<ReadonlyArray<Maybe<GQLCapsuleMission>>>;
  readonly original_launch: Maybe<Scalars['Date']>;
  readonly reuse_count: Maybe<Scalars['Int']>;
  readonly rtls_attempts: Maybe<Scalars['Int']>;
  readonly rtls_landings: Maybe<Scalars['Int']>;
  readonly status: Maybe<Scalars['String']>;
  readonly water_landing: Maybe<Scalars['Boolean']>;
};

export type GQLCoreMission = {
  readonly __typename?: 'CoreMission';
  readonly flight: Maybe<Scalars['Int']>;
  readonly name: Maybe<Scalars['String']>;
};

export type GQLCoresFind = {
  readonly asds_attempts: InputMaybe<Scalars['Int']>;
  readonly asds_landings: InputMaybe<Scalars['Int']>;
  readonly block: InputMaybe<Scalars['Int']>;
  readonly id: InputMaybe<Scalars['String']>;
  readonly missions: InputMaybe<Scalars['String']>;
  readonly original_launch: InputMaybe<Scalars['Date']>;
  readonly reuse_count: InputMaybe<Scalars['Int']>;
  readonly rtls_attempts: InputMaybe<Scalars['Int']>;
  readonly rtls_landings: InputMaybe<Scalars['Int']>;
  readonly status: InputMaybe<Scalars['String']>;
  readonly water_landing: InputMaybe<Scalars['Boolean']>;
};

export type GQLDistance = {
  readonly __typename?: 'Distance';
  readonly feet: Maybe<Scalars['Float']>;
  readonly meters: Maybe<Scalars['Float']>;
};

export type GQLDragon = {
  readonly __typename?: 'Dragon';
  readonly active: Maybe<Scalars['Boolean']>;
  readonly crew_capacity: Maybe<Scalars['Int']>;
  readonly description: Maybe<Scalars['String']>;
  readonly diameter: Maybe<GQLDistance>;
  readonly dry_mass_kg: Maybe<Scalars['Int']>;
  readonly dry_mass_lb: Maybe<Scalars['Int']>;
  readonly first_flight: Maybe<Scalars['String']>;
  readonly heat_shield: Maybe<GQLDragonHeatShield>;
  readonly height_w_trunk: Maybe<GQLDistance>;
  readonly id: Maybe<Scalars['ID']>;
  readonly launch_payload_mass: Maybe<GQLMass>;
  readonly launch_payload_vol: Maybe<GQLVolume>;
  readonly name: Maybe<Scalars['String']>;
  readonly orbit_duration_yr: Maybe<Scalars['Int']>;
  readonly pressurized_capsule: Maybe<GQLDragonPressurizedCapsule>;
  readonly return_payload_mass: Maybe<GQLMass>;
  readonly return_payload_vol: Maybe<GQLVolume>;
  readonly sidewall_angle_deg: Maybe<Scalars['Float']>;
  readonly thrusters: Maybe<ReadonlyArray<Maybe<GQLDragonThrust>>>;
  readonly trunk: Maybe<GQLDragonTrunk>;
  readonly type: Maybe<Scalars['String']>;
  readonly wikipedia: Maybe<Scalars['String']>;
};

export type GQLDragonHeatShield = {
  readonly __typename?: 'DragonHeatShield';
  readonly dev_partner: Maybe<Scalars['String']>;
  readonly material: Maybe<Scalars['String']>;
  readonly size_meters: Maybe<Scalars['Float']>;
  readonly temp_degrees: Maybe<Scalars['Int']>;
};

export type GQLDragonPressurizedCapsule = {
  readonly __typename?: 'DragonPressurizedCapsule';
  readonly payload_volume: Maybe<GQLVolume>;
};

export type GQLDragonThrust = {
  readonly __typename?: 'DragonThrust';
  readonly amount: Maybe<Scalars['Int']>;
  readonly fuel_1: Maybe<Scalars['String']>;
  readonly fuel_2: Maybe<Scalars['String']>;
  readonly pods: Maybe<Scalars['Int']>;
  readonly thrust: Maybe<GQLForce>;
  readonly type: Maybe<Scalars['String']>;
};

export type GQLDragonTrunk = {
  readonly __typename?: 'DragonTrunk';
  readonly cargo: Maybe<GQLDragonTrunkCargo>;
  readonly trunk_volume: Maybe<GQLVolume>;
};

export type GQLDragonTrunkCargo = {
  readonly __typename?: 'DragonTrunkCargo';
  readonly solar_array: Maybe<Scalars['Int']>;
  readonly unpressurized_cargo: Maybe<Scalars['Boolean']>;
};

export type GQLForce = {
  readonly __typename?: 'Force';
  readonly kN: Maybe<Scalars['Float']>;
  readonly lbf: Maybe<Scalars['Float']>;
};

export type GQLHistoriesResult = {
  readonly __typename?: 'HistoriesResult';
  readonly data: Maybe<ReadonlyArray<Maybe<GQLHistory>>>;
  readonly result: Maybe<GQLResult>;
};

export type GQLHistory = {
  readonly __typename?: 'History';
  readonly details: Maybe<Scalars['String']>;
  readonly event_date_unix: Maybe<Scalars['Date']>;
  readonly event_date_utc: Maybe<Scalars['Date']>;
  readonly flight: Maybe<GQLLaunch>;
  readonly id: Maybe<Scalars['ID']>;
  readonly links: Maybe<GQLLink>;
  readonly title: Maybe<Scalars['String']>;
};

export type GQLHistoryFind = {
  readonly end: InputMaybe<Scalars['Date']>;
  readonly flight_number: InputMaybe<Scalars['Int']>;
  readonly id: InputMaybe<Scalars['ID']>;
  readonly start: InputMaybe<Scalars['Date']>;
};

export type GQLInfo = {
  readonly __typename?: 'Info';
  readonly ceo: Maybe<Scalars['String']>;
  readonly coo: Maybe<Scalars['String']>;
  readonly cto: Maybe<Scalars['String']>;
  readonly cto_propulsion: Maybe<Scalars['String']>;
  readonly employees: Maybe<Scalars['Int']>;
  readonly founded: Maybe<Scalars['Int']>;
  readonly founder: Maybe<Scalars['String']>;
  readonly headquarters: Maybe<GQLAddress>;
  readonly launch_sites: Maybe<Scalars['Int']>;
  readonly links: Maybe<GQLInfoLinks>;
  readonly name: Maybe<Scalars['String']>;
  readonly summary: Maybe<Scalars['String']>;
  readonly test_sites: Maybe<Scalars['Int']>;
  readonly valuation: Maybe<Scalars['Float']>;
  readonly vehicles: Maybe<Scalars['Int']>;
};

export type GQLInfoLinks = {
  readonly __typename?: 'InfoLinks';
  readonly elon_twitter: Maybe<Scalars['String']>;
  readonly flickr: Maybe<Scalars['String']>;
  readonly twitter: Maybe<Scalars['String']>;
  readonly website: Maybe<Scalars['String']>;
};

export type GQLLandpad = {
  readonly __typename?: 'Landpad';
  readonly attempted_landings: Maybe<Scalars['String']>;
  readonly details: Maybe<Scalars['String']>;
  readonly full_name: Maybe<Scalars['String']>;
  readonly id: Maybe<Scalars['ID']>;
  readonly landing_type: Maybe<Scalars['String']>;
  readonly location: Maybe<GQLLocation>;
  readonly status: Maybe<Scalars['String']>;
  readonly successful_landings: Maybe<Scalars['String']>;
  readonly wikipedia: Maybe<Scalars['String']>;
};

export type GQLLaunch = {
  readonly __typename?: 'Launch';
  readonly details: Maybe<Scalars['String']>;
  readonly id: Maybe<Scalars['ID']>;
  readonly is_tentative: Maybe<Scalars['Boolean']>;
  readonly launch_date_local: Maybe<Scalars['Date']>;
  readonly launch_date_unix: Maybe<Scalars['Date']>;
  readonly launch_date_utc: Maybe<Scalars['Date']>;
  readonly launch_site: Maybe<GQLLaunchSite>;
  readonly launch_success: Maybe<Scalars['Boolean']>;
  readonly launch_year: Maybe<Scalars['String']>;
  readonly links: Maybe<GQLLaunchLinks>;
  readonly mission_id: Maybe<ReadonlyArray<Maybe<Scalars['String']>>>;
  readonly mission_name: Maybe<Scalars['String']>;
  readonly rocket: Maybe<GQLLaunchRocket>;
  readonly ships: Maybe<ReadonlyArray<Maybe<GQLShip>>>;
  readonly static_fire_date_unix: Maybe<Scalars['Date']>;
  readonly static_fire_date_utc: Maybe<Scalars['Date']>;
  readonly telemetry: Maybe<GQLLaunchTelemetry>;
  readonly tentative_max_precision: Maybe<Scalars['String']>;
  readonly upcoming: Maybe<Scalars['Boolean']>;
};

export type GQLLaunchFind = {
  readonly apoapsis_km: InputMaybe<Scalars['Float']>;
  readonly block: InputMaybe<Scalars['Int']>;
  readonly cap_serial: InputMaybe<Scalars['String']>;
  readonly capsule_reuse: InputMaybe<Scalars['String']>;
  readonly core_flight: InputMaybe<Scalars['Int']>;
  readonly core_reuse: InputMaybe<Scalars['String']>;
  readonly core_serial: InputMaybe<Scalars['String']>;
  readonly customer: InputMaybe<Scalars['String']>;
  readonly eccentricity: InputMaybe<Scalars['Float']>;
  readonly end: InputMaybe<Scalars['Date']>;
  readonly epoch: InputMaybe<Scalars['Date']>;
  readonly fairings_recovered: InputMaybe<Scalars['String']>;
  readonly fairings_recovery_attempt: InputMaybe<Scalars['String']>;
  readonly fairings_reuse: InputMaybe<Scalars['String']>;
  readonly fairings_reused: InputMaybe<Scalars['String']>;
  readonly fairings_ship: InputMaybe<Scalars['String']>;
  readonly gridfins: InputMaybe<Scalars['String']>;
  readonly id: InputMaybe<Scalars['ID']>;
  readonly inclination_deg: InputMaybe<Scalars['Float']>;
  readonly land_success: InputMaybe<Scalars['String']>;
  readonly landing_intent: InputMaybe<Scalars['String']>;
  readonly landing_type: InputMaybe<Scalars['String']>;
  readonly landing_vehicle: InputMaybe<Scalars['String']>;
  readonly launch_date_local: InputMaybe<Scalars['Date']>;
  readonly launch_date_utc: InputMaybe<Scalars['Date']>;
  readonly launch_success: InputMaybe<Scalars['String']>;
  readonly launch_year: InputMaybe<Scalars['String']>;
  readonly legs: InputMaybe<Scalars['String']>;
  readonly lifespan_years: InputMaybe<Scalars['Float']>;
  readonly longitude: InputMaybe<Scalars['Float']>;
  readonly manufacturer: InputMaybe<Scalars['String']>;
  readonly mean_motion: InputMaybe<Scalars['Float']>;
  readonly mission_id: InputMaybe<Scalars['String']>;
  readonly mission_name: InputMaybe<Scalars['String']>;
  readonly nationality: InputMaybe<Scalars['String']>;
  readonly norad_id: InputMaybe<Scalars['Int']>;
  readonly orbit: InputMaybe<Scalars['String']>;
  readonly payload_id: InputMaybe<Scalars['String']>;
  readonly payload_type: InputMaybe<Scalars['String']>;
  readonly periapsis_km: InputMaybe<Scalars['Float']>;
  readonly period_min: InputMaybe<Scalars['Float']>;
  readonly raan: InputMaybe<Scalars['Float']>;
  readonly reference_system: InputMaybe<Scalars['String']>;
  readonly regime: InputMaybe<Scalars['String']>;
  readonly reused: InputMaybe<Scalars['String']>;
  readonly rocket_id: InputMaybe<Scalars['String']>;
  readonly rocket_name: InputMaybe<Scalars['String']>;
  readonly rocket_type: InputMaybe<Scalars['String']>;
  readonly second_stage_block: InputMaybe<Scalars['String']>;
  readonly semi_major_axis_km: InputMaybe<Scalars['Float']>;
  readonly ship: InputMaybe<Scalars['String']>;
  readonly side_core1_reuse: InputMaybe<Scalars['String']>;
  readonly side_core2_reuse: InputMaybe<Scalars['String']>;
  readonly site_id: InputMaybe<Scalars['String']>;
  readonly site_name: InputMaybe<Scalars['String']>;
  readonly site_name_long: InputMaybe<Scalars['String']>;
  readonly start: InputMaybe<Scalars['Date']>;
  readonly tbd: InputMaybe<Scalars['String']>;
  readonly tentative: InputMaybe<Scalars['String']>;
  readonly tentative_max_precision: InputMaybe<Scalars['String']>;
};

export type GQLLaunchLinks = {
  readonly __typename?: 'LaunchLinks';
  readonly article_link: Maybe<Scalars['String']>;
  readonly flickr_images: Maybe<ReadonlyArray<Maybe<Scalars['String']>>>;
  readonly mission_patch: Maybe<Scalars['String']>;
  readonly mission_patch_small: Maybe<Scalars['String']>;
  readonly presskit: Maybe<Scalars['String']>;
  readonly reddit_campaign: Maybe<Scalars['String']>;
  readonly reddit_launch: Maybe<Scalars['String']>;
  readonly reddit_media: Maybe<Scalars['String']>;
  readonly reddit_recovery: Maybe<Scalars['String']>;
  readonly video_link: Maybe<Scalars['String']>;
  readonly wikipedia: Maybe<Scalars['String']>;
};

export type GQLLaunchRocket = {
  readonly __typename?: 'LaunchRocket';
  readonly fairings: Maybe<GQLLaunchRocketFairings>;
  readonly first_stage: Maybe<GQLLaunchRocketFirstStage>;
  readonly rocket: Maybe<GQLRocket>;
  readonly rocket_name: Maybe<Scalars['String']>;
  readonly rocket_type: Maybe<Scalars['String']>;
  readonly second_stage: Maybe<GQLLaunchRocketSecondStage>;
};

export type GQLLaunchRocketFairings = {
  readonly __typename?: 'LaunchRocketFairings';
  readonly recovered: Maybe<Scalars['Boolean']>;
  readonly recovery_attempt: Maybe<Scalars['Boolean']>;
  readonly reused: Maybe<Scalars['Boolean']>;
  readonly ship: Maybe<Scalars['String']>;
};

export type GQLLaunchRocketFirstStage = {
  readonly __typename?: 'LaunchRocketFirstStage';
  readonly cores: Maybe<ReadonlyArray<Maybe<GQLLaunchRocketFirstStageCore>>>;
};

export type GQLLaunchRocketFirstStageCore = {
  readonly __typename?: 'LaunchRocketFirstStageCore';
  readonly block: Maybe<Scalars['Int']>;
  readonly core: Maybe<GQLCore>;
  readonly flight: Maybe<Scalars['Int']>;
  readonly gridfins: Maybe<Scalars['Boolean']>;
  readonly land_success: Maybe<Scalars['Boolean']>;
  readonly landing_intent: Maybe<Scalars['Boolean']>;
  readonly landing_type: Maybe<Scalars['String']>;
  readonly landing_vehicle: Maybe<Scalars['String']>;
  readonly legs: Maybe<Scalars['Boolean']>;
  readonly reused: Maybe<Scalars['Boolean']>;
};

export type GQLLaunchRocketSecondStage = {
  readonly __typename?: 'LaunchRocketSecondStage';
  readonly block: Maybe<Scalars['Int']>;
  readonly payloads: Maybe<ReadonlyArray<Maybe<GQLPayload>>>;
};

export type GQLLaunchSite = {
  readonly __typename?: 'LaunchSite';
  readonly site_id: Maybe<Scalars['String']>;
  readonly site_name: Maybe<Scalars['String']>;
  readonly site_name_long: Maybe<Scalars['String']>;
};

export type GQLLaunchTelemetry = {
  readonly __typename?: 'LaunchTelemetry';
  readonly flight_club: Maybe<Scalars['String']>;
};

export type GQLLaunchesPastResult = {
  readonly __typename?: 'LaunchesPastResult';
  readonly data: Maybe<ReadonlyArray<Maybe<GQLLaunch>>>;
  readonly result: Maybe<GQLResult>;
};

export type GQLLaunchpad = {
  readonly __typename?: 'Launchpad';
  readonly attempted_launches: Maybe<Scalars['Int']>;
  readonly details: Maybe<Scalars['String']>;
  readonly id: Maybe<Scalars['ID']>;
  readonly location: Maybe<GQLLocation>;
  readonly name: Maybe<Scalars['String']>;
  readonly status: Maybe<Scalars['String']>;
  readonly successful_launches: Maybe<Scalars['Int']>;
  readonly vehicles_launched: Maybe<ReadonlyArray<Maybe<GQLRocket>>>;
  readonly wikipedia: Maybe<Scalars['String']>;
};

export type GQLLink = {
  readonly __typename?: 'Link';
  readonly article: Maybe<Scalars['String']>;
  readonly reddit: Maybe<Scalars['String']>;
  readonly wikipedia: Maybe<Scalars['String']>;
};

export type GQLLocation = {
  readonly __typename?: 'Location';
  readonly latitude: Maybe<Scalars['Float']>;
  readonly longitude: Maybe<Scalars['Float']>;
  readonly name: Maybe<Scalars['String']>;
  readonly region: Maybe<Scalars['String']>;
};

export type GQLMass = {
  readonly __typename?: 'Mass';
  readonly kg: Maybe<Scalars['Int']>;
  readonly lb: Maybe<Scalars['Int']>;
};

export type GQLMission = {
  readonly __typename?: 'Mission';
  readonly description: Maybe<Scalars['String']>;
  readonly id: Maybe<Scalars['ID']>;
  readonly manufacturers: Maybe<ReadonlyArray<Maybe<Scalars['String']>>>;
  readonly name: Maybe<Scalars['String']>;
  readonly payloads: Maybe<ReadonlyArray<Maybe<GQLPayload>>>;
  readonly twitter: Maybe<Scalars['String']>;
  readonly website: Maybe<Scalars['String']>;
  readonly wikipedia: Maybe<Scalars['String']>;
};

export type GQLMissionResult = {
  readonly __typename?: 'MissionResult';
  readonly data: Maybe<ReadonlyArray<Maybe<GQLMission>>>;
  readonly result: Maybe<GQLResult>;
};

export type GQLMissionsFind = {
  readonly id: InputMaybe<Scalars['ID']>;
  readonly manufacturer: InputMaybe<Scalars['String']>;
  readonly name: InputMaybe<Scalars['String']>;
  readonly payload_id: InputMaybe<Scalars['String']>;
};

export type GQLMutation = {
  readonly __typename?: 'Mutation';
  /** delete data from the table: "users" */
  readonly delete_users: Maybe<GQLUsers_Mutation_Response>;
  /** insert data into the table: "users" */
  readonly insert_users: Maybe<GQLUsers_Mutation_Response>;
  /** update data of the table: "users" */
  readonly update_users: Maybe<GQLUsers_Mutation_Response>;
};


export type GQLMutationDelete_UsersArgs = {
  where: GQLUsers_Bool_Exp;
};


export type GQLMutationInsert_UsersArgs = {
  objects: ReadonlyArray<GQLUsers_Insert_Input>;
  on_conflict: InputMaybe<GQLUsers_On_Conflict>;
};


export type GQLMutationUpdate_UsersArgs = {
  _set: InputMaybe<GQLUsers_Set_Input>;
  where: GQLUsers_Bool_Exp;
};

export type GQLPayload = {
  readonly __typename?: 'Payload';
  readonly customers: Maybe<ReadonlyArray<Maybe<Scalars['String']>>>;
  readonly id: Maybe<Scalars['ID']>;
  readonly manufacturer: Maybe<Scalars['String']>;
  readonly nationality: Maybe<Scalars['String']>;
  readonly norad_id: Maybe<ReadonlyArray<Maybe<Scalars['Int']>>>;
  readonly orbit: Maybe<Scalars['String']>;
  readonly orbit_params: Maybe<GQLPayloadOrbitParams>;
  readonly payload_mass_kg: Maybe<Scalars['Float']>;
  readonly payload_mass_lbs: Maybe<Scalars['Float']>;
  readonly payload_type: Maybe<Scalars['String']>;
  readonly reused: Maybe<Scalars['Boolean']>;
};

export type GQLPayloadOrbitParams = {
  readonly __typename?: 'PayloadOrbitParams';
  readonly apoapsis_km: Maybe<Scalars['Float']>;
  readonly arg_of_pericenter: Maybe<Scalars['Float']>;
  readonly eccentricity: Maybe<Scalars['Float']>;
  readonly epoch: Maybe<Scalars['Date']>;
  readonly inclination_deg: Maybe<Scalars['Float']>;
  readonly lifespan_years: Maybe<Scalars['Float']>;
  readonly longitude: Maybe<Scalars['Float']>;
  readonly mean_anomaly: Maybe<Scalars['Float']>;
  readonly mean_motion: Maybe<Scalars['Float']>;
  readonly periapsis_km: Maybe<Scalars['Float']>;
  readonly period_min: Maybe<Scalars['Float']>;
  readonly raan: Maybe<Scalars['Float']>;
  readonly reference_system: Maybe<Scalars['String']>;
  readonly regime: Maybe<Scalars['String']>;
  readonly semi_major_axis_km: Maybe<Scalars['Float']>;
};

export type GQLPayloadsFind = {
  readonly apoapsis_km: InputMaybe<Scalars['Float']>;
  readonly customer: InputMaybe<Scalars['String']>;
  readonly eccentricity: InputMaybe<Scalars['Float']>;
  readonly epoch: InputMaybe<Scalars['Date']>;
  readonly inclination_deg: InputMaybe<Scalars['Float']>;
  readonly lifespan_years: InputMaybe<Scalars['Float']>;
  readonly longitude: InputMaybe<Scalars['Float']>;
  readonly manufacturer: InputMaybe<Scalars['String']>;
  readonly mean_motion: InputMaybe<Scalars['Float']>;
  readonly nationality: InputMaybe<Scalars['String']>;
  readonly norad_id: InputMaybe<Scalars['Int']>;
  readonly orbit: InputMaybe<Scalars['String']>;
  readonly payload_id: InputMaybe<Scalars['ID']>;
  readonly payload_type: InputMaybe<Scalars['String']>;
  readonly periapsis_km: InputMaybe<Scalars['Float']>;
  readonly period_min: InputMaybe<Scalars['Float']>;
  readonly raan: InputMaybe<Scalars['Float']>;
  readonly reference_system: InputMaybe<Scalars['String']>;
  readonly regime: InputMaybe<Scalars['String']>;
  readonly reused: InputMaybe<Scalars['Boolean']>;
  readonly semi_major_axis_km: InputMaybe<Scalars['Float']>;
};

export type GQLQuery = {
  readonly __typename?: 'Query';
  readonly capsule: Maybe<GQLCapsule>;
  readonly capsules: Maybe<ReadonlyArray<Maybe<GQLCapsule>>>;
  readonly capsulesPast: Maybe<ReadonlyArray<Maybe<GQLCapsule>>>;
  readonly capsulesUpcoming: Maybe<ReadonlyArray<Maybe<GQLCapsule>>>;
  readonly company: Maybe<GQLInfo>;
  readonly core: Maybe<GQLCore>;
  readonly cores: Maybe<ReadonlyArray<Maybe<GQLCore>>>;
  readonly coresPast: Maybe<ReadonlyArray<Maybe<GQLCore>>>;
  readonly coresUpcoming: Maybe<ReadonlyArray<Maybe<GQLCore>>>;
  readonly dragon: Maybe<GQLDragon>;
  readonly dragons: Maybe<ReadonlyArray<Maybe<GQLDragon>>>;
  readonly histories: Maybe<ReadonlyArray<Maybe<GQLHistory>>>;
  readonly historiesResult: Maybe<GQLHistoriesResult>;
  readonly history: Maybe<GQLHistory>;
  readonly landpad: Maybe<GQLLandpad>;
  readonly landpads: Maybe<ReadonlyArray<Maybe<GQLLandpad>>>;
  readonly launch: Maybe<GQLLaunch>;
  readonly launchLatest: Maybe<GQLLaunch>;
  readonly launchNext: Maybe<GQLLaunch>;
  readonly launches: Maybe<ReadonlyArray<Maybe<GQLLaunch>>>;
  readonly launchesPast: Maybe<ReadonlyArray<Maybe<GQLLaunch>>>;
  readonly launchesPastResult: Maybe<GQLLaunchesPastResult>;
  readonly launchesUpcoming: Maybe<ReadonlyArray<Maybe<GQLLaunch>>>;
  readonly launchpad: Maybe<GQLLaunchpad>;
  readonly launchpads: Maybe<ReadonlyArray<Maybe<GQLLaunchpad>>>;
  readonly mission: Maybe<GQLMission>;
  readonly missions: Maybe<ReadonlyArray<Maybe<GQLMission>>>;
  readonly missionsResult: Maybe<GQLMissionResult>;
  readonly payload: Maybe<GQLPayload>;
  readonly payloads: Maybe<ReadonlyArray<Maybe<GQLPayload>>>;
  readonly roadster: Maybe<GQLRoadster>;
  readonly rocket: Maybe<GQLRocket>;
  readonly rockets: Maybe<ReadonlyArray<Maybe<GQLRocket>>>;
  readonly rocketsResult: Maybe<GQLRocketsResult>;
  readonly ship: Maybe<GQLShip>;
  readonly ships: Maybe<ReadonlyArray<Maybe<GQLShip>>>;
  readonly shipsResult: Maybe<GQLShipsResult>;
  /** fetch data from the table: "users" */
  readonly users: ReadonlyArray<GQLUsers>;
  /** fetch aggregated fields from the table: "users" */
  readonly users_aggregate: GQLUsers_Aggregate;
  /** fetch data from the table: "users" using primary key columns */
  readonly users_by_pk: Maybe<GQLUsers>;
};


export type GQLQueryCapsuleArgs = {
  id: Scalars['ID'];
};


export type GQLQueryCapsulesArgs = {
  find: InputMaybe<GQLCapsulesFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryCapsulesPastArgs = {
  find: InputMaybe<GQLCapsulesFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryCapsulesUpcomingArgs = {
  find: InputMaybe<GQLCapsulesFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryCoreArgs = {
  id: Scalars['ID'];
};


export type GQLQueryCoresArgs = {
  find: InputMaybe<GQLCoresFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryCoresPastArgs = {
  find: InputMaybe<GQLCoresFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryCoresUpcomingArgs = {
  find: InputMaybe<GQLCoresFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryDragonArgs = {
  id: Scalars['ID'];
};


export type GQLQueryDragonsArgs = {
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryHistoriesArgs = {
  find: InputMaybe<GQLHistoryFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryHistoriesResultArgs = {
  find: InputMaybe<GQLHistoryFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryHistoryArgs = {
  id: Scalars['ID'];
};


export type GQLQueryLandpadArgs = {
  id: Scalars['ID'];
};


export type GQLQueryLandpadsArgs = {
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryLaunchArgs = {
  id: Scalars['ID'];
};


export type GQLQueryLaunchLatestArgs = {
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryLaunchNextArgs = {
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryLaunchesArgs = {
  find: InputMaybe<GQLLaunchFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryLaunchesPastArgs = {
  find: InputMaybe<GQLLaunchFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryLaunchesPastResultArgs = {
  find: InputMaybe<GQLLaunchFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryLaunchesUpcomingArgs = {
  find: InputMaybe<GQLLaunchFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryLaunchpadArgs = {
  id: Scalars['ID'];
};


export type GQLQueryLaunchpadsArgs = {
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryMissionArgs = {
  id: Scalars['ID'];
};


export type GQLQueryMissionsArgs = {
  find: InputMaybe<GQLMissionsFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryMissionsResultArgs = {
  find: InputMaybe<GQLMissionsFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryPayloadArgs = {
  id: Scalars['ID'];
};


export type GQLQueryPayloadsArgs = {
  find: InputMaybe<GQLPayloadsFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryRocketArgs = {
  id: Scalars['ID'];
};


export type GQLQueryRocketsArgs = {
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryRocketsResultArgs = {
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
};


export type GQLQueryShipArgs = {
  id: Scalars['ID'];
};


export type GQLQueryShipsArgs = {
  find: InputMaybe<GQLShipsFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryShipsResultArgs = {
  find: InputMaybe<GQLShipsFind>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order: InputMaybe<Scalars['String']>;
  sort: InputMaybe<Scalars['String']>;
};


export type GQLQueryUsersArgs = {
  distinct_on: InputMaybe<ReadonlyArray<GQLUsers_Select_Column>>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order_by: InputMaybe<ReadonlyArray<GQLUsers_Order_By>>;
  where: InputMaybe<GQLUsers_Bool_Exp>;
};


export type GQLQueryUsers_AggregateArgs = {
  distinct_on: InputMaybe<ReadonlyArray<GQLUsers_Select_Column>>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order_by: InputMaybe<ReadonlyArray<GQLUsers_Order_By>>;
  where: InputMaybe<GQLUsers_Bool_Exp>;
};


export type GQLQueryUsers_By_PkArgs = {
  id: Scalars['uuid'];
};

export type GQLResult = {
  readonly __typename?: 'Result';
  readonly totalCount: Maybe<Scalars['Int']>;
};

export type GQLRoadster = {
  readonly __typename?: 'Roadster';
  readonly apoapsis_au: Maybe<Scalars['Float']>;
  readonly details: Maybe<Scalars['String']>;
  readonly earth_distance_km: Maybe<Scalars['Float']>;
  readonly earth_distance_mi: Maybe<Scalars['Float']>;
  readonly eccentricity: Maybe<Scalars['Float']>;
  readonly epoch_jd: Maybe<Scalars['Float']>;
  readonly inclination: Maybe<Scalars['Float']>;
  readonly launch_date_unix: Maybe<Scalars['Date']>;
  readonly launch_date_utc: Maybe<Scalars['Date']>;
  readonly launch_mass_kg: Maybe<Scalars['Int']>;
  readonly launch_mass_lbs: Maybe<Scalars['Int']>;
  readonly longitude: Maybe<Scalars['Float']>;
  readonly mars_distance_km: Maybe<Scalars['Float']>;
  readonly mars_distance_mi: Maybe<Scalars['Float']>;
  readonly name: Maybe<Scalars['String']>;
  readonly norad_id: Maybe<Scalars['Int']>;
  readonly orbit_type: Maybe<Scalars['Float']>;
  readonly periapsis_arg: Maybe<Scalars['Float']>;
  readonly periapsis_au: Maybe<Scalars['Float']>;
  readonly period_days: Maybe<Scalars['Float']>;
  readonly semi_major_axis_au: Maybe<Scalars['Float']>;
  readonly speed_kph: Maybe<Scalars['Float']>;
  readonly speed_mph: Maybe<Scalars['Float']>;
  readonly wikipedia: Maybe<Scalars['String']>;
};

export type GQLRocket = {
  readonly __typename?: 'Rocket';
  readonly active: Maybe<Scalars['Boolean']>;
  readonly boosters: Maybe<Scalars['Int']>;
  readonly company: Maybe<Scalars['String']>;
  readonly cost_per_launch: Maybe<Scalars['Int']>;
  readonly country: Maybe<Scalars['String']>;
  readonly description: Maybe<Scalars['String']>;
  readonly diameter: Maybe<GQLDistance>;
  readonly engines: Maybe<GQLRocketEngines>;
  readonly first_flight: Maybe<Scalars['Date']>;
  readonly first_stage: Maybe<GQLRocketFirstStage>;
  readonly height: Maybe<GQLDistance>;
  readonly id: Maybe<Scalars['ID']>;
  readonly landing_legs: Maybe<GQLRocketLandingLegs>;
  readonly mass: Maybe<GQLMass>;
  readonly name: Maybe<Scalars['String']>;
  readonly payload_weights: Maybe<ReadonlyArray<Maybe<GQLRocketPayloadWeight>>>;
  readonly second_stage: Maybe<GQLRocketSecondStage>;
  readonly stages: Maybe<Scalars['Int']>;
  readonly success_rate_pct: Maybe<Scalars['Int']>;
  readonly type: Maybe<Scalars['String']>;
  readonly wikipedia: Maybe<Scalars['String']>;
};

export type GQLRocketEngines = {
  readonly __typename?: 'RocketEngines';
  readonly engine_loss_max: Maybe<Scalars['String']>;
  readonly layout: Maybe<Scalars['String']>;
  readonly number: Maybe<Scalars['Int']>;
  readonly propellant_1: Maybe<Scalars['String']>;
  readonly propellant_2: Maybe<Scalars['String']>;
  readonly thrust_sea_level: Maybe<GQLForce>;
  readonly thrust_to_weight: Maybe<Scalars['Float']>;
  readonly thrust_vacuum: Maybe<GQLForce>;
  readonly type: Maybe<Scalars['String']>;
  readonly version: Maybe<Scalars['String']>;
};

export type GQLRocketFirstStage = {
  readonly __typename?: 'RocketFirstStage';
  readonly burn_time_sec: Maybe<Scalars['Int']>;
  readonly engines: Maybe<Scalars['Int']>;
  readonly fuel_amount_tons: Maybe<Scalars['Float']>;
  readonly reusable: Maybe<Scalars['Boolean']>;
  readonly thrust_sea_level: Maybe<GQLForce>;
  readonly thrust_vacuum: Maybe<GQLForce>;
};

export type GQLRocketLandingLegs = {
  readonly __typename?: 'RocketLandingLegs';
  readonly material: Maybe<Scalars['String']>;
  readonly number: Maybe<Scalars['Int']>;
};

export type GQLRocketPayloadWeight = {
  readonly __typename?: 'RocketPayloadWeight';
  readonly id: Maybe<Scalars['String']>;
  readonly kg: Maybe<Scalars['Int']>;
  readonly lb: Maybe<Scalars['Int']>;
  readonly name: Maybe<Scalars['String']>;
};

export type GQLRocketSecondStage = {
  readonly __typename?: 'RocketSecondStage';
  readonly burn_time_sec: Maybe<Scalars['Int']>;
  readonly engines: Maybe<Scalars['Int']>;
  readonly fuel_amount_tons: Maybe<Scalars['Float']>;
  readonly payloads: Maybe<GQLRocketSecondStagePayloads>;
  readonly thrust: Maybe<GQLForce>;
};

export type GQLRocketSecondStagePayloadCompositeFairing = {
  readonly __typename?: 'RocketSecondStagePayloadCompositeFairing';
  readonly diameter: Maybe<GQLDistance>;
  readonly height: Maybe<GQLDistance>;
};

export type GQLRocketSecondStagePayloads = {
  readonly __typename?: 'RocketSecondStagePayloads';
  readonly composite_fairing: Maybe<GQLRocketSecondStagePayloadCompositeFairing>;
  readonly option_1: Maybe<Scalars['String']>;
};

export type GQLRocketsResult = {
  readonly __typename?: 'RocketsResult';
  readonly data: Maybe<ReadonlyArray<Maybe<GQLRocket>>>;
  readonly result: Maybe<GQLResult>;
};

export type GQLShip = {
  readonly __typename?: 'Ship';
  readonly abs: Maybe<Scalars['Int']>;
  readonly active: Maybe<Scalars['Boolean']>;
  readonly attempted_landings: Maybe<Scalars['Int']>;
  readonly class: Maybe<Scalars['Int']>;
  readonly course_deg: Maybe<Scalars['Int']>;
  readonly home_port: Maybe<Scalars['String']>;
  readonly id: Maybe<Scalars['ID']>;
  readonly image: Maybe<Scalars['String']>;
  readonly imo: Maybe<Scalars['Int']>;
  readonly missions: Maybe<ReadonlyArray<Maybe<GQLShipMission>>>;
  readonly mmsi: Maybe<Scalars['Int']>;
  readonly model: Maybe<Scalars['String']>;
  readonly name: Maybe<Scalars['String']>;
  readonly position: Maybe<GQLShipLocation>;
  readonly roles: Maybe<ReadonlyArray<Maybe<Scalars['String']>>>;
  readonly speed_kn: Maybe<Scalars['Float']>;
  readonly status: Maybe<Scalars['String']>;
  readonly successful_landings: Maybe<Scalars['Int']>;
  readonly type: Maybe<Scalars['String']>;
  readonly url: Maybe<Scalars['String']>;
  readonly weight_kg: Maybe<Scalars['Int']>;
  readonly weight_lbs: Maybe<Scalars['Int']>;
  readonly year_built: Maybe<Scalars['Int']>;
};

export type GQLShipLocation = {
  readonly __typename?: 'ShipLocation';
  readonly latitude: Maybe<Scalars['Float']>;
  readonly longitude: Maybe<Scalars['Float']>;
};

export type GQLShipMission = {
  readonly __typename?: 'ShipMission';
  readonly flight: Maybe<Scalars['String']>;
  readonly name: Maybe<Scalars['String']>;
};

export type GQLShipsFind = {
  readonly abs: InputMaybe<Scalars['Int']>;
  readonly active: InputMaybe<Scalars['Boolean']>;
  readonly attempted_landings: InputMaybe<Scalars['Int']>;
  readonly class: InputMaybe<Scalars['Int']>;
  readonly course_deg: InputMaybe<Scalars['Int']>;
  readonly home_port: InputMaybe<Scalars['String']>;
  readonly id: InputMaybe<Scalars['ID']>;
  readonly imo: InputMaybe<Scalars['Int']>;
  readonly latitude: InputMaybe<Scalars['Float']>;
  readonly longitude: InputMaybe<Scalars['Float']>;
  readonly mission: InputMaybe<Scalars['String']>;
  readonly mmsi: InputMaybe<Scalars['Int']>;
  readonly model: InputMaybe<Scalars['String']>;
  readonly name: InputMaybe<Scalars['String']>;
  readonly role: InputMaybe<Scalars['String']>;
  readonly speed_kn: InputMaybe<Scalars['Int']>;
  readonly status: InputMaybe<Scalars['String']>;
  readonly successful_landings: InputMaybe<Scalars['Int']>;
  readonly type: InputMaybe<Scalars['String']>;
  readonly weight_kg: InputMaybe<Scalars['Int']>;
  readonly weight_lbs: InputMaybe<Scalars['Int']>;
  readonly year_built: InputMaybe<Scalars['Int']>;
};

export type GQLShipsResult = {
  readonly __typename?: 'ShipsResult';
  readonly data: Maybe<ReadonlyArray<Maybe<GQLShip>>>;
  readonly result: Maybe<GQLResult>;
};

/** expression to compare columns of type String. All fields are combined with logical 'AND'. */
export type GQLString_Comparison_Exp = {
  readonly _eq: InputMaybe<Scalars['String']>;
  readonly _gt: InputMaybe<Scalars['String']>;
  readonly _gte: InputMaybe<Scalars['String']>;
  readonly _ilike: InputMaybe<Scalars['String']>;
  readonly _in: InputMaybe<ReadonlyArray<Scalars['String']>>;
  readonly _is_null: InputMaybe<Scalars['Boolean']>;
  readonly _like: InputMaybe<Scalars['String']>;
  readonly _lt: InputMaybe<Scalars['String']>;
  readonly _lte: InputMaybe<Scalars['String']>;
  readonly _neq: InputMaybe<Scalars['String']>;
  readonly _nilike: InputMaybe<Scalars['String']>;
  readonly _nin: InputMaybe<ReadonlyArray<Scalars['String']>>;
  readonly _nlike: InputMaybe<Scalars['String']>;
  readonly _nsimilar: InputMaybe<Scalars['String']>;
  readonly _similar: InputMaybe<Scalars['String']>;
};

export type GQLSubscription = {
  readonly __typename?: 'Subscription';
  /** fetch data from the table: "users" */
  readonly users: ReadonlyArray<GQLUsers>;
  /** fetch aggregated fields from the table: "users" */
  readonly users_aggregate: GQLUsers_Aggregate;
  /** fetch data from the table: "users" using primary key columns */
  readonly users_by_pk: Maybe<GQLUsers>;
};


export type GQLSubscriptionUsersArgs = {
  distinct_on: InputMaybe<ReadonlyArray<GQLUsers_Select_Column>>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order_by: InputMaybe<ReadonlyArray<GQLUsers_Order_By>>;
  where: InputMaybe<GQLUsers_Bool_Exp>;
};


export type GQLSubscriptionUsers_AggregateArgs = {
  distinct_on: InputMaybe<ReadonlyArray<GQLUsers_Select_Column>>;
  limit: InputMaybe<Scalars['Int']>;
  offset: InputMaybe<Scalars['Int']>;
  order_by: InputMaybe<ReadonlyArray<GQLUsers_Order_By>>;
  where: InputMaybe<GQLUsers_Bool_Exp>;
};


export type GQLSubscriptionUsers_By_PkArgs = {
  id: Scalars['uuid'];
};

export type GQLVolume = {
  readonly __typename?: 'Volume';
  readonly cubic_feet: Maybe<Scalars['Int']>;
  readonly cubic_meters: Maybe<Scalars['Int']>;
};

/** conflict action */
export enum GQLConflict_Action {
  /** ignore the insert on this row */
  Ignore = 'ignore',
  /** update the row with the given values */
  Update = 'update'
}

/** column ordering options */
export enum GQLOrder_By {
  /** in the ascending order, nulls last */
  Asc = 'asc',
  /** in the ascending order, nulls first */
  AscNullsFirst = 'asc_nulls_first',
  /** in the ascending order, nulls last */
  AscNullsLast = 'asc_nulls_last',
  /** in the descending order, nulls first */
  Desc = 'desc',
  /** in the descending order, nulls first */
  DescNullsFirst = 'desc_nulls_first',
  /** in the descending order, nulls last */
  DescNullsLast = 'desc_nulls_last'
}

/** expression to compare columns of type timestamptz. All fields are combined with logical 'AND'. */
export type GQLTimestamptz_Comparison_Exp = {
  readonly _eq: InputMaybe<Scalars['timestamptz']>;
  readonly _gt: InputMaybe<Scalars['timestamptz']>;
  readonly _gte: InputMaybe<Scalars['timestamptz']>;
  readonly _in: InputMaybe<ReadonlyArray<Scalars['timestamptz']>>;
  readonly _is_null: InputMaybe<Scalars['Boolean']>;
  readonly _lt: InputMaybe<Scalars['timestamptz']>;
  readonly _lte: InputMaybe<Scalars['timestamptz']>;
  readonly _neq: InputMaybe<Scalars['timestamptz']>;
  readonly _nin: InputMaybe<ReadonlyArray<Scalars['timestamptz']>>;
};

/** columns and relationships of "users" */
export type GQLUsers = {
  readonly __typename?: 'users';
  readonly id: Scalars['uuid'];
  readonly name: Maybe<Scalars['String']>;
  readonly rocket: Maybe<Scalars['String']>;
  readonly timestamp: Scalars['timestamptz'];
  readonly twitter: Maybe<Scalars['String']>;
};

/** aggregated selection of "users" */
export type GQLUsers_Aggregate = {
  readonly __typename?: 'users_aggregate';
  readonly aggregate: Maybe<GQLUsers_Aggregate_Fields>;
  readonly nodes: ReadonlyArray<GQLUsers>;
};

/** aggregate fields of "users" */
export type GQLUsers_Aggregate_Fields = {
  readonly __typename?: 'users_aggregate_fields';
  readonly count: Maybe<Scalars['Int']>;
  readonly max: Maybe<GQLUsers_Max_Fields>;
  readonly min: Maybe<GQLUsers_Min_Fields>;
};


/** aggregate fields of "users" */
export type GQLUsers_Aggregate_FieldsCountArgs = {
  columns: InputMaybe<ReadonlyArray<GQLUsers_Select_Column>>;
  distinct: InputMaybe<Scalars['Boolean']>;
};

/** order by aggregate values of table "users" */
export type GQLUsers_Aggregate_Order_By = {
  readonly count: InputMaybe<GQLOrder_By>;
  readonly max: InputMaybe<GQLUsers_Max_Order_By>;
  readonly min: InputMaybe<GQLUsers_Min_Order_By>;
};

/** input type for inserting array relation for remote table "users" */
export type GQLUsers_Arr_Rel_Insert_Input = {
  readonly data: ReadonlyArray<GQLUsers_Insert_Input>;
  readonly on_conflict: InputMaybe<GQLUsers_On_Conflict>;
};

/** Boolean expression to filter rows from the table "users". All fields are combined with a logical 'AND'. */
export type GQLUsers_Bool_Exp = {
  readonly _and: InputMaybe<ReadonlyArray<InputMaybe<GQLUsers_Bool_Exp>>>;
  readonly _not: InputMaybe<GQLUsers_Bool_Exp>;
  readonly _or: InputMaybe<ReadonlyArray<InputMaybe<GQLUsers_Bool_Exp>>>;
  readonly id: InputMaybe<GQLUuid_Comparison_Exp>;
  readonly name: InputMaybe<GQLString_Comparison_Exp>;
  readonly rocket: InputMaybe<GQLString_Comparison_Exp>;
  readonly timestamp: InputMaybe<GQLTimestamptz_Comparison_Exp>;
  readonly twitter: InputMaybe<GQLString_Comparison_Exp>;
};

/** unique or primary key constraints on table "users" */
export enum GQLUsers_Constraint {
  /** unique or primary key constraint */
  UsersPkey = 'users_pkey'
}

/** input type for inserting data into table "users" */
export type GQLUsers_Insert_Input = {
  readonly id: InputMaybe<Scalars['uuid']>;
  readonly name: InputMaybe<Scalars['String']>;
  readonly rocket: InputMaybe<Scalars['String']>;
  readonly timestamp: InputMaybe<Scalars['timestamptz']>;
  readonly twitter: InputMaybe<Scalars['String']>;
};

/** aggregate max on columns */
export type GQLUsers_Max_Fields = {
  readonly __typename?: 'users_max_fields';
  readonly name: Maybe<Scalars['String']>;
  readonly rocket: Maybe<Scalars['String']>;
  readonly timestamp: Maybe<Scalars['timestamptz']>;
  readonly twitter: Maybe<Scalars['String']>;
};

/** order by max() on columns of table "users" */
export type GQLUsers_Max_Order_By = {
  readonly name: InputMaybe<GQLOrder_By>;
  readonly rocket: InputMaybe<GQLOrder_By>;
  readonly timestamp: InputMaybe<GQLOrder_By>;
  readonly twitter: InputMaybe<GQLOrder_By>;
};

/** aggregate min on columns */
export type GQLUsers_Min_Fields = {
  readonly __typename?: 'users_min_fields';
  readonly name: Maybe<Scalars['String']>;
  readonly rocket: Maybe<Scalars['String']>;
  readonly timestamp: Maybe<Scalars['timestamptz']>;
  readonly twitter: Maybe<Scalars['String']>;
};

/** order by min() on columns of table "users" */
export type GQLUsers_Min_Order_By = {
  readonly name: InputMaybe<GQLOrder_By>;
  readonly rocket: InputMaybe<GQLOrder_By>;
  readonly timestamp: InputMaybe<GQLOrder_By>;
  readonly twitter: InputMaybe<GQLOrder_By>;
};

/** response of any mutation on the table "users" */
export type GQLUsers_Mutation_Response = {
  readonly __typename?: 'users_mutation_response';
  /** number of affected rows by the mutation */
  readonly affected_rows: Scalars['Int'];
  /** data of the affected rows by the mutation */
  readonly returning: ReadonlyArray<GQLUsers>;
};

/** input type for inserting object relation for remote table "users" */
export type GQLUsers_Obj_Rel_Insert_Input = {
  readonly data: GQLUsers_Insert_Input;
  readonly on_conflict: InputMaybe<GQLUsers_On_Conflict>;
};

/** on conflict condition type for table "users" */
export type GQLUsers_On_Conflict = {
  readonly constraint: GQLUsers_Constraint;
  readonly update_columns: ReadonlyArray<GQLUsers_Update_Column>;
};

/** ordering options when selecting data from "users" */
export type GQLUsers_Order_By = {
  readonly id: InputMaybe<GQLOrder_By>;
  readonly name: InputMaybe<GQLOrder_By>;
  readonly rocket: InputMaybe<GQLOrder_By>;
  readonly timestamp: InputMaybe<GQLOrder_By>;
  readonly twitter: InputMaybe<GQLOrder_By>;
};

/** select columns of table "users" */
export enum GQLUsers_Select_Column {
  /** column name */
  Id = 'id',
  /** column name */
  Name = 'name',
  /** column name */
  Rocket = 'rocket',
  /** column name */
  Timestamp = 'timestamp',
  /** column name */
  Twitter = 'twitter'
}

/** input type for updating data in table "users" */
export type GQLUsers_Set_Input = {
  readonly id: InputMaybe<Scalars['uuid']>;
  readonly name: InputMaybe<Scalars['String']>;
  readonly rocket: InputMaybe<Scalars['String']>;
  readonly timestamp: InputMaybe<Scalars['timestamptz']>;
  readonly twitter: InputMaybe<Scalars['String']>;
};

/** update columns of table "users" */
export enum GQLUsers_Update_Column {
  /** column name */
  Id = 'id',
  /** column name */
  Name = 'name',
  /** column name */
  Rocket = 'rocket',
  /** column name */
  Timestamp = 'timestamp',
  /** column name */
  Twitter = 'twitter'
}

/** expression to compare columns of type uuid. All fields are combined with logical 'AND'. */
export type GQLUuid_Comparison_Exp = {
  readonly _eq: InputMaybe<Scalars['uuid']>;
  readonly _gt: InputMaybe<Scalars['uuid']>;
  readonly _gte: InputMaybe<Scalars['uuid']>;
  readonly _in: InputMaybe<ReadonlyArray<Scalars['uuid']>>;
  readonly _is_null: InputMaybe<Scalars['Boolean']>;
  readonly _lt: InputMaybe<Scalars['uuid']>;
  readonly _lte: InputMaybe<Scalars['uuid']>;
  readonly _neq: InputMaybe<Scalars['uuid']>;
  readonly _nin: InputMaybe<ReadonlyArray<Scalars['uuid']>>;
};

export type GQLLaunchpadsManyQueryVariables = Exact<{ [key: string]: never; }>;


export type GQLLaunchpadsManyQuery = { readonly __typename?: 'Query', readonly launchpads: ReadonlyArray<{ readonly __typename?: 'Launchpad', readonly id: string, readonly name: string, readonly successful_launches: number, readonly status: string, readonly location: { readonly __typename?: 'Location', readonly name: string } }> };

export type GQLLaunchByYearQueryVariables = Exact<{
  year: Scalars['String'];
}>;


export type GQLLaunchByYearQuery = { readonly __typename?: 'Query', readonly launches: ReadonlyArray<{ readonly __typename?: 'Launch', readonly mission_id: ReadonlyArray<string>, readonly mission_name: string, readonly launch_date_utc: any, readonly rocket: { readonly __typename?: 'LaunchRocket', readonly rocket_name: string } }> };


export const LaunchpadsManyDocument = gql`
    query LaunchpadsMany {
  launchpads(limit: 10) {
    id
    name
    location {
      name
    }
    successful_launches
    status
  }
}
    `;
export const LaunchByYearDocument = gql`
    query LaunchByYear($year: String!) {
  launches(find: {launch_year: $year}) {
    mission_id
    mission_name
    launch_date_utc
    rocket {
      rocket_name
    }
  }
}
    `;

export type SdkFunctionWrapper = <T>(action: (requestHeaders?:Record<string, string>) => Promise<T>, operationName: string) => Promise<T>;


const defaultWrapper: SdkFunctionWrapper = (action, _operationName) => action();

export function getSdk(client: GraphQLClient, withWrapper: SdkFunctionWrapper = defaultWrapper) {
  return {
    LaunchpadsMany(variables?: GQLLaunchpadsManyQueryVariables, requestHeaders?: Dom.RequestInit["headers"]): Promise<GQLLaunchpadsManyQuery> {
      return withWrapper((wrappedRequestHeaders) => client.request<GQLLaunchpadsManyQuery>(LaunchpadsManyDocument, variables, {...requestHeaders, ...wrappedRequestHeaders}), 'LaunchpadsMany');
    },
    LaunchByYear(variables: GQLLaunchByYearQueryVariables, requestHeaders?: Dom.RequestInit["headers"]): Promise<GQLLaunchByYearQuery> {
      return withWrapper((wrappedRequestHeaders) => client.request<GQLLaunchByYearQuery>(LaunchByYearDocument, variables, {...requestHeaders, ...wrappedRequestHeaders}), 'LaunchByYear');
    }
  };
}
export type Sdk = ReturnType<typeof getSdk>;